unit BMtGL;

{$reference 'System.Windows.Forms.dll'}
{$reference 'System.Drawing.dll'}
type
  LoadType = (RGB, RGBA);

function LoadOpenGLImage(image: string; w, h: ^integer; LT: LoadType): array of byte;
begin
  var b := new System.Drawing.Bitmap(image);
  var LTL: byte;
  case LT of
    RGB: LTL := 3;
    RGBA: LTL := 4;
  end;
  var sp: cardinal;
  Result := new byte[b.Width * b.Height * LTL];
  for x: integer := 0 to b.Width - 1 do
    for y: integer := 0 to b.Height - 1 do
    begin
      sp := (x + y * b.Width) * LTL;
      var c := b.GetPixel(x, y);
      Result[sp + 0] := c.R;
      Result[sp + 1] := c.G;
      Result[sp + 2] := c.B;
      if LT = RGBA then
        Result[sp + 3] := c.A;
    end;
  w^ := b.Width;
  h^ := b.Height;
  //Result := Result + Result + Result + Result + Result + Result + Result + Result;
end;

end.